"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var info_1 = __importDefault(require("./info"));
var os_1 = __importDefault(require("./os"));
var trimEnd_1 = __importDefault(require("lodash/trimEnd"));
var child_process_1 = __importDefault(require("child_process"));
var kleur_1 = __importDefault(require("kleur"));
var separator = (0, os_1.default)() === 'windows'
    ? ' && '
    : '; ';
var info = function (type, message) {
    var msg = message.trim();
    if (!msg)
        return;
    msg = msg
        .replace(/\r/g, '\n')
        .replace(/\n{2,}/g, '');
    msg = type === 'error'
        ? kleur_1.default.red(msg)
        : kleur_1.default.gray(msg);
    console.log(msg);
};
var main = function (cmd, option) {
    if (option === void 0) { option = {}; }
    var stringCmd = cmd instanceof Array
        ? cmd.join(separator)
        : cmd;
    var _a = (0, os_1.default)('macos')
        ? ['/bin/sh', ['-c', stringCmd]]
        : ['cmd.exe', ['/s', '/c', stringCmd]], cmder = _a[0], arg = _a[1];
    if (!option.silent)
        (0, info_1.default)('exec', stringCmd);
    return new Promise(function (resolve) {
        var result = '';
        var process = child_process_1.default.spawn(cmder, arg, {});
        process.stderr.on('data', function (data) {
            result = parseMessage(data);
            if (!option.silent)
                info('error', data.toString());
        });
        process.stdout.on('data', function (data) {
            result = parseMessage(data);
            if (!option.silent)
                info('default', data.toString());
        });
        process.on('close', function (code) {
            if (code === 0 || option.ignoreError)
                resolve([true, result]);
            resolve([false, result]);
        });
    });
};
var parseMessage = function (buffer) { return (0, trimEnd_1.default)(buffer.toString(), '\n'); };
exports.default = main;
