import watch from './watch';
declare const $: {
    argv: <T = {
        [x: string]: unknown;
    }>() => T & {
        [x: string]: unknown;
        _: (string | number)[];
        $0: string;
    };
    backup: (source: string | string[]) => Promise<void>;
    clean: (source: string | string[]) => Promise<void>;
    compile: {
        (source: string | string[], Option?: Partial<{
            bare: boolean;
            base: string;
            minify: boolean;
            sourcemaps: boolean;
        }> | undefined): Promise<void>;
        (source: string | string[], target: string, option?: Partial<{
            bare: boolean;
            base: string;
            minify: boolean;
            sourcemaps: boolean;
        }> | undefined): Promise<void>;
    };
    copy: (source: string | string[], target: string, option?: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    } | undefined) => Promise<void>;
    download: (source: string, target: string, option?: string | Partial<import("./download").Option>) => Promise<void>;
    exec: (cmd: string | string[], option?: {
        ignoreError?: boolean | undefined;
        silent?: boolean | undefined;
    }) => Promise<[boolean, string]>;
    formatArgument: {
        (input: boolean): boolean[];
        (input: number): number[];
        (input: string | string[]): string[];
        (input: unknown): unknown[];
    };
    getBasename: (input: string) => string;
    getDirname: (input: string) => string;
    getExtname: (input: string) => string;
    getFilename: (input: string) => string;
    getName: (input: string) => {
        basename: string;
        dirname: string;
        extname: string;
        filename: string;
    };
    home: () => string;
    i: <T_1>(input: T_1) => T_1;
    info: {
        <T_2>(...args: [T_2] | [string, T_2]): T_2;
        freeze: <T_3>(callback: Promise<T_3> | (() => Promise<T_3>)) => Promise<T_3>;
        isFrozen: boolean;
        isSilent: boolean;
        pause: () => void;
        resume: () => void;
        whisper: <T_4>(callback: Promise<T_4> | (() => Promise<T_4>)) => Promise<T_4>;
    };
    isExisted: (source: string | string[]) => Promise<boolean>;
    isSame: (source: string | string[]) => Promise<boolean>;
    link: (source: string, target: string) => Promise<void>;
    mkdir: (source: string | string[]) => Promise<void>;
    move: (source: string | string[], target: string, option?: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    } | undefined) => Promise<void>;
    normalizePath: (source: string) => string;
    normalizePathToArray: (source: string | string[]) => string[];
    os: <T_5 extends void | ("" | "unknown" | "macos" | "windows") | ("" | "unknown" | "macos" | "windows")[] = void>(os?: T_5 | undefined) => T_5 extends void ? "" | "unknown" | "macos" | "windows" : boolean;
    parseJson: {
        <T_6>(input: unknown): T_6;
        (input: unknown): unknown[] | {
            [x: string]: unknown;
        };
    };
    parseString: (input: unknown) => string;
    prompt: <T_7, U extends "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi" = "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi">(option: (U extends "confirm" ? {
        type: "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "confirm";
        default?: boolean | undefined;
    } : U extends "number" ? {
        type: "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "number";
        default?: number | undefined;
        max: number;
        min: number;
    } : U extends "auto" | "select" | "multi" ? {
        type: "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "auto" | "select" | "multi";
        default?: string | number | undefined;
        list: (T_7 | {
            title: string;
            description?: string | undefined;
            value: T_7;
            disabled?: boolean | undefined;
        })[];
    } : U extends "text" ? {
        type: "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "text";
        default?: string | undefined;
    } : U extends "toggle" ? {
        type: "number" | "auto" | "toggle" | "select" | "text" | "confirm" | "multi";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "toggle";
        default?: boolean | undefined;
        off?: string | undefined;
        on?: string | undefined;
    } : never) & {
        list?: (T_7 | {
            title: string;
            description?: string | undefined;
            value: T_7;
            disabled?: boolean | undefined;
        })[] | undefined;
        type: U;
    }) => Promise<T_7 extends undefined ? U extends "confirm" ? boolean : U extends "number" ? number : U extends "auto" | "select" | "multi" ? T_7 : U extends "text" ? string : U extends "toggle" ? boolean : never : T_7>;
    read: <U_1 = undefined, T_8 extends string = string>(source: T_8, option?: {
        raw: boolean;
    } | undefined) => Promise<U_1 extends undefined ? (T_8 extends `${string}.js` | `${string}.coffee` | `${string}.css` | `${string}.html` | `${string}.md` | `${string}.pug` | `${string}.styl` | `${string}.ts` | `${string}.sh` | `${string}.tsx` | `${string}.txt` | `${string}.xml` ? string : T_8 extends `${string}.json` | `${string}.yaml` | `${string}.yml` ? {
        [x: string]: unknown;
    } : Buffer) | undefined : U_1>;
    recover: (source: string | string[]) => Promise<void>;
    remove: (source: string | string[]) => Promise<void>;
    rename: (source: string | string[], option: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    }) => Promise<void>;
    root: () => string;
    say: (text: string, option?: {
        lang?: "ja" | "ja-jp" | "zh" | "zh-cn" | "zh-hk" | "zh-tw" | undefined;
        voice?: "kyoko" | "ting-ting" | "sin-ji" | "mei-jia" | undefined;
    }) => Promise<void>;
    sleep: (delay?: number) => Promise<void>;
    source: (source: string | string[] | (string[] & {
        __is_listed_as_source__?: boolean | undefined;
    })) => Promise<string[]>;
    stat: (source: string) => Promise<import("fs").Stats | null>;
    type: (input: unknown) => string;
    watch: typeof watch;
    wrapList: (input: unknown) => string;
    write: (source: string, content: unknown, option?: string | {
        encoding?: string | null | undefined;
        flag?: string | undefined;
        mode?: number | undefined;
    } | undefined) => Promise<boolean>;
    zip: (source: string | string[], target?: string, option?: string | {
        base?: string | undefined;
        filename?: string | undefined;
    }) => Promise<void>;
};
export default $;
