"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var findIndex_1 = __importDefault(require("lodash/findIndex"));
var info_1 = __importDefault(require("./info"));
var parseString_1 = __importDefault(require("./parseString"));
var read_1 = __importDefault(require("./read"));
var write_1 = __importDefault(require("./write"));
var prompts_1 = __importDefault(require("prompts"));
var listType = [
    'auto',
    'confirm',
    'multi',
    'number',
    'select',
    'text',
    'toggle',
];
var listTypePrompt = [
    'autocomplete',
    'confirm',
    'multiselect',
    'number',
    'select',
    'text',
    'toggle',
];
var mapMessageDefault = {
    auto: 'input',
    confirm: 'confirm',
    multi: 'select',
    number: 'input number',
    select: 'select',
    text: 'input text',
    toggle: 'toggle',
};
var pathCache = './temp/cache-prompt.json';
var formatOption = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var result, _a, result, _b, list, result, _c, _d, _e, result, _f, result, _g;
    var _h, _j, _k, _l, _m;
    return __generator(this, function (_o) {
        switch (_o.label) {
            case 0:
                if (!(option.type === 'confirm')) return [3, 3];
                _h = {};
                _a = option.default;
                if (_a) return [3, 2];
                return [4, getCache(option)];
            case 1:
                _a = (_o.sent());
                _o.label = 2;
            case 2:
                result = (_h.initial = _a || false,
                    _h.message = option.message || mapMessageDefault.confirm || '',
                    _h.name = 'value',
                    _h.type = 'confirm',
                    _h);
                return [2, result];
            case 3:
                if (!(option.type === 'number')) return [3, 6];
                _j = {};
                _b = option.default;
                if (_b) return [3, 5];
                return [4, getCache(option)];
            case 4:
                _b = (_o.sent());
                _o.label = 5;
            case 5:
                result = (_j.initial = _b || option.min || 0,
                    _j.max = option.max,
                    _j.message = option.message || mapMessageDefault.number || '',
                    _j.min = option.min,
                    _j.name = 'value',
                    _j.type = 'number',
                    _j);
                return [2, result];
            case 6:
                if (!(option.type === 'auto'
                    || option.type === 'multi'
                    || option.type === 'select')) return [3, 9];
                list = transChoice(option.list);
                _k = {
                    choices: list
                };
                _c = pickDefault;
                _d = [list];
                _e = option.default;
                if (_e) return [3, 8];
                return [4, getCache(option)];
            case 7:
                _e = (_o.sent());
                _o.label = 8;
            case 8:
                result = (_k.initial = _c.apply(void 0, _d.concat([_e])) || 0,
                    _k.message = option.message || mapMessageDefault[option.type] || '',
                    _k.name = 'value',
                    _k.type = transType(option.type),
                    _k);
                return [2, result];
            case 9:
                if (!(option.type === 'text')) return [3, 12];
                _l = {};
                _f = option.default;
                if (_f) return [3, 11];
                return [4, getCache(option)];
            case 10:
                _f = (_o.sent());
                _o.label = 11;
            case 11:
                result = (_l.initial = _f || '',
                    _l.message = option.message || mapMessageDefault.text || '',
                    _l.name = 'value',
                    _l.type = 'text',
                    _l);
                return [2, result];
            case 12:
                if (!(option.type === 'toggle')) return [3, 15];
                _m = {
                    active: option.on || 'on',
                    inactive: option.off || 'off'
                };
                _g = option.default;
                if (_g) return [3, 14];
                return [4, getCache(option)];
            case 13:
                _g = (_o.sent());
                _o.label = 14;
            case 14:
                result = (_m.initial = _g || false,
                    _m.message = option.message || mapMessageDefault.toggle || '',
                    _m.name = 'value',
                    _m.type = 'toggle',
                    _m);
                return [2, result];
            case 15: throw new Error("invalid type '" + option.type + "'");
        }
    });
}); };
var getCache = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var id, type, cache, data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                id = option.id, type = option.type;
                if (!id)
                    return [2, undefined];
                if (type === 'multi')
                    return [2, undefined];
                return [4, (0, read_1.default)(pathCache)];
            case 1:
                cache = _a.sent();
                if (!cache)
                    return [2, undefined];
                data = cache[id];
                if (!data)
                    return [2, undefined];
                if (type !== data.type)
                    return [2, undefined];
                return [2, data.value];
        }
    });
}); };
var isChoice = function (input) { return typeof input === 'object'; };
var main = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var opt, result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!option)
                    throw new Error('prompt/error: empty option');
                info_1.default.pause();
                return [4, formatOption(option)];
            case 1:
                opt = _a.sent();
                return [4, (0, prompts_1.default)(opt)];
            case 2:
                result = (_a.sent())[opt.name];
                return [4, setCache(option, result)];
            case 3:
                _a.sent();
                info_1.default.resume();
                return [2, result];
        }
    });
}); };
var pickDefault = function (list, value) {
    if (value === void 0) { value = 0; }
    if (typeof value === 'number') {
        if (value >= 0) {
            if (value > list.length - 1)
                return list.length - 1;
            return value;
        }
        if (0 - value - 1 < 0)
            return 0;
        return list.length + value;
    }
    return (0, findIndex_1.default)(list, function (it) { return value === it.value; });
};
var setCache = function (option, value) { return __awaiter(void 0, void 0, void 0, function () {
    var id, type, cache;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                id = option.id, type = option.type;
                if (!id)
                    return [2];
                if (type === 'multi')
                    return [2];
                return [4, (0, read_1.default)(pathCache)];
            case 1:
                cache = (_a.sent()) || {};
                cache[id] = { type: type, value: value };
                return [4, (0, write_1.default)(pathCache, cache)];
            case 2:
                _a.sent();
                return [2];
        }
    });
}); };
var transChoice = function (list) { return list.map(function (it) { return (isChoice(it)
    ? it
    : {
        title: (0, parseString_1.default)(it),
        value: it,
    }); }); };
var transType = function (type) {
    if (type === 'auto')
        return 'autocomplete';
    if (type === 'multi')
        return 'multiselect';
    return 'select';
};
exports.default = main;
